import { Observable, Subject } from 'rxjs';
interface IAction {
    type: string;
    payload?: any;
}
declare const INIT_STORE_ACTION: IAction;
interface IReducer<S> {
    (action: IAction, state: S): S;
}
declare const createStore: <S>(reducersRoot: IReducer<S>, effectsRoot?: IEffect<S>) => {
    state$: Observable<S>;
    dispatch(action: any): void;
    destroy$: Subject<void>;
};
declare type TReducersObject<S extends Object> = {
    [P in keyof S]: IReducer<S[P]>;
};
declare const combineReducers: <S>(reducers: TReducersObject<S>, initialState?: S) => (action: IAction, state?: S) => any;
interface IEffect<S> {
    (actions$: Observable<IAction>, store$: Observable<S>): Observable<IAction>;
}
declare const combineEffects: <S>(...effects: IEffect<S>[]) => IEffect<S>;
export { INIT_STORE_ACTION, createStore, combineReducers, combineEffects };
